import { Envelope } from "../schema/envelope";
import { Payload } from "../schema/payload";
import * as ogs from "object-graph-streamer";
export interface GeneratorProps<T = unknown> {
    readonly simpleEnvelopeProps: SimpleEnvelopeProps<T>;
    readonly hash: string;
    readonly t: number;
}
export interface SimpleEnvelopeProps<T = unknown> {
    readonly id?: string;
    readonly src: string;
    readonly dst?: string[];
    readonly t?: Date | number;
    readonly ttl?: number;
    readonly data: Payload<T>;
    readonly jsonProp?: Partial<ogs.JsonProps>;
    readonly idGenerator?: (props: GeneratorProps<T>) => string;
}
export declare function tHashIdGenerator<T>(props: GeneratorProps<T>): string;
export declare function hashIdGenerator<T>(props: GeneratorProps<T>): string;
export declare class SimpleEnvelope<T> {
    readonly simpleEnvelopeProps: SimpleEnvelopeProps<T>;
    readonly envJsonStrings: string[];
    readonly envJsonC: ogs.JsonCollector;
    envelope?: Envelope<T>;
    dataJsonHash?: ogs.JsonHash;
    constructor(env: SimpleEnvelopeProps<T>);
    asDataJson(): string;
    asJson(): string;
    asEnvelope(): Envelope<T>;
    private toDataJson;
    lazy(): this;
}
export declare function simpleEnvelope<T>(env: SimpleEnvelopeProps<T>): SimpleEnvelope<T>;
//# sourceMappingURL=simpleEnvelope.d.ts.map