"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.simpleEnvelope = exports.SimpleEnvelope = exports.hashIdGenerator = exports.tHashIdGenerator = void 0;
var ogs = __importStar(require("object-graph-streamer"));
function tHashIdGenerator(props) {
    return "".concat(props.t, "-").concat(props.hash);
}
exports.tHashIdGenerator = tHashIdGenerator;
function hashIdGenerator(props) {
    return props.hash;
}
exports.hashIdGenerator = hashIdGenerator;
var SimpleEnvelope = /** @class */ (function () {
    function SimpleEnvelope(env) {
        var _this = this;
        this.envJsonStrings = [];
        this.simpleEnvelopeProps = __assign(__assign({}, env), { idGenerator: env.idGenerator ? env.idGenerator : tHashIdGenerator });
        this.envJsonC = new ogs.JsonCollector(function (part) { return _this.envJsonStrings.push(part); }, this.simpleEnvelopeProps.jsonProp);
    }
    SimpleEnvelope.prototype.asDataJson = function () {
        return this.dataJsonHash.jsonStr;
    };
    SimpleEnvelope.prototype.asJson = function () {
        var str = this.lazy().envJsonStrings.join("");
        // Caution
        this.asJson = function () { return str; };
        return str;
    };
    SimpleEnvelope.prototype.asEnvelope = function () {
        var _this = this;
        // Caution
        this.asEnvelope = function () { return _this.envelope; };
        return this.lazy().envelope;
    };
    SimpleEnvelope.prototype.toDataJson = function () {
        var dataJsonStrings = [];
        var dataJsonC = new ogs.JsonCollector(function (part) { return dataJsonStrings.push(part); }, __assign(__assign({}, this.simpleEnvelopeProps.jsonProp), { 
            // "data": { "data": { this stuff } } ==> 2
            newLine: "\n" +
                Array(2 * ((this.simpleEnvelopeProps.jsonProp || {}).indent || 0))
                    .fill(" ")
                    .join("") }));
        var dataHashC = undefined;
        var dataProcessor;
        if (this.simpleEnvelopeProps.id) {
            dataProcessor = function (sval) {
                dataJsonC.append(sval);
            };
        }
        else {
            dataHashC = new ogs.HashCollector();
            dataProcessor = function (sval) {
                // console.log("dataP:", sval);
                dataHashC.append(sval);
                dataJsonC.append(sval);
            };
        }
        ogs.objectGraphStreamer(this.simpleEnvelopeProps.data.data, dataProcessor);
        // da muss das hin
        return {
            jsonStr: dataJsonStrings.join(""),
            hash: dataHashC ? dataHashC.digest() : undefined,
        };
    };
    SimpleEnvelope.prototype.lazy = function () {
        var _this = this;
        this.dataJsonHash = this.toDataJson();
        var t;
        if (this.simpleEnvelopeProps.t instanceof Date) {
            t = this.simpleEnvelopeProps.t.getTime();
        }
        else {
            t = this.simpleEnvelopeProps.t || (new Date()).getTime();
        }
        var envelope = {
            v: "A",
            id: this.simpleEnvelopeProps.id || this.simpleEnvelopeProps.idGenerator({
                t: t,
                hash: this.dataJsonHash.hash, simpleEnvelopeProps: this.simpleEnvelopeProps
            }),
            src: this.simpleEnvelopeProps.src,
            dst: this.simpleEnvelopeProps.dst || [],
            t: t,
            ttl: this.simpleEnvelopeProps.ttl || 10,
            data: __assign(__assign({}, this.simpleEnvelopeProps.data), { data: undefined }),
        };
        var nextValue = false;
        ogs.objectGraphStreamer(envelope, function (sval) {
            var oval = sval;
            if (sval.attribute === "data") {
                nextValue = true;
            }
            else if (nextValue) {
                if (sval.val && sval.val.asValue() === undefined) {
                    oval = __assign(__assign({}, sval), { val: new ogs.PlainValType(_this.asDataJson()) });
                }
                nextValue = false;
            }
            _this.envJsonC.append(oval);
        });
        this.envelope = __assign(__assign({}, envelope), { data: __assign(__assign({}, envelope.data), { data: this.simpleEnvelopeProps.data.data }) });
        // Caution
        this.lazy = function () { return _this; };
        return this;
    };
    return SimpleEnvelope;
}());
exports.SimpleEnvelope = SimpleEnvelope;
function simpleEnvelope(env) {
    return new SimpleEnvelope(env);
}
exports.simpleEnvelope = simpleEnvelope;
//# sourceMappingURL=simpleEnvelope.js.map